C
C    ******* INM - RSHU Chemistry-Climate Model 0-120 km *******
C
      PROGRAM CCM120 
C 
      IMPLICIT REAL (A-H,O-Z) 
      INCLUDE 'basp.h'                                                  ! Basic parameters
      INCLUDE 'PRMT.INC'                                                ! CCM dimensions 
      PARAMETER(NC=76,NY=73)                                            ! Number of chemical gases
      INCLUDE 'xx.h'                                                    ! Chemistry arrays
C      INCLUDE 'mpif.h' 
C 
      COMMON /HISPS/ PSDAY4(NLONP2,NLAT),PSDAY(NLONP2,NLAT)             ! Surface pressure
      COMMON/GEN/GEN(12),KEY(20)                                        ! Control point
      COMMON/GRIDF/SHIR(NLAT),SC(NLAT),SCSC1(NLAT)                      ! Latitude grid
      COMMON/COMMEM/IAA(3),IAR(3,2) 
      COMMON/HELPD/GVS,G124,GKL,GF,DS2(NLEV) 
      COMMON /MEMORY/ X(LENTX)                                          ! Climate one-dimensional array
      COMMON /TRACER/ XX(LENTXX)                                        ! Chemistry one-dimensional array
      COMMON/RAB5/DT,SC1,APPA,R,CP,TST,AI,OMEGA 
      COMMON/RAB3/PRIS(24) 
      INTEGER OLI,OLIM 
      COMMON /PHYS/  TS(NLONP2,NLAT),PRES(NLONP2,NLAT),                 ! Boundary laayer arrays
     *  GAL(NLONP2,NLAT),SS(NLONP2,NLAT),WW(NLONP2,NLAT), 
     *  HSN(NLONP2,NLAT),HLT(NLONP2,NLAT),TX(NLONP2,NLAT), 
     *  TY(NLONP2,NLAT),QS(NLONP2,NLAT),QQ(NLONP2,NLEV,NLAT), 
     *  DEL(NLONP2,NLAT),EPSR(NLONP2,NLEV,NLAT),OLI(NLONP2,9), 
     *  FS(NLONP2,NLAT+1),OLIM(NLONP2,NLAT) 
      COMMON/GRIDS/SIG(NLEV),SIGC(NLEV),DSIG(NLEV)                      ! Vertical grid
      COMMON /IRAB4/ I,IL,J,JL,KG,J1,K1,JN,I1,I2,I3 
      COMMON/LEN/LEN2,LEN3,L2,L4,NDIN 
      COMMON/NN/N,NK,N0,ND,N99,NUM,KTSTEP 
      COMMON/HELP/DT1,DS(NLEV),DS1(NLEV) 
      COMMON /RADI11/ SF(NR21),NFLX(NLEV+1),NDAT(NLEV+1) 
      COMMON /RADI15/ SCLD(3),ALS(3),BES(3),ALBZ(3),ALBW(3),PGLW(3) 
      COMMON /RADI16/ QCO2GG,SOL,AZCLD(2),RELE(2),ESS(NLAT),CDISSE 
      COMMON /RADI12/ U123(NLON,3),TAUR(NLON),FR(NLON),U(NLON) 
      COMMON /RADI17/ E(NLON,10),FAL(11),TGR(NLON),OZONCM(NLON) 
      COMMON /RADI/   HSG(NLAT),OZON(NLAT),COZ(NLONP2,NLAT) 
      COMMON/BDGLRD/ IFLAG,PCLD(NLON,8),PFG(NLON,8), 
     *  PF1(NLON,8),ALB(NLON,8),BLNSG(NLON,8),BALANS(NLON,8) 
      COMMON/CESS/C1(NLONP2,NLAT),C2(NLONP2,NLAT),C3(NLONP2,NLAT), 
     * F(NLONP2,NLAT) 
     *  ,Q(NLONP2,NLAT),BL(NLONP2,NLAT),F7(NLONP2,NLAT),Q7(NLONP2,NLAT), 
     *  BL7(NLONP2,NLAT) 
     * ,PW(NLONP2,NLAT),FG(NLONP2,NLAT),SG(NLONP2,NLAT),C(NLONP2,NLAT) 
      COMMON /RND/ FGC(NLONP2,NLAT), SGC(NLONP2,NLAT), RG(NLONP2,NLAT), 
     * SOMOCD(NLONP2,NLAT) 
      COMMON /SW/ SW(NLONP2,NLAT) 
      COMMON /TSALB/ TSBLD(NLONP2,NLAT),ALBEDO(NLONP2,NLAT), 
     * QSBLD(NLONP2,NLAT) 
      COMMON/RHZON/RHZON(NLAT,NLEV),CLDZ(NLAT,NLEV),THZON(NLAT,NLEV), 
     *             QHZON(NLAT,NLEV) 
C       COMMON/CSTEPJ/ CSTEP(15540)        !  KL=21  MEHE 
      COMMON /SSTICE/ SST1(NLONP2,NLAT),SIC1(NLONP2,NLAT), 
     *                SST2(NLONP2,NLAT),SIC2(NLONP2,NLAT) 
      COMMON /MXMON/ LNMON(12),MDAY1,MDAY 
      DIMENSION SST(NLONP2,NLAT),SIC(NLONP2,NLAT)                       ! Sea surface temperature and sea ice coverage
      COMMON /COMVDF/ AR211(NLONP2,NLAT),VDCDIA(NLONP2,NLAT) 
      COMMON /CONCLA/ CONCLD(NLONP2,NLAT),IKUO,IADJ,RUNOFF(NLONP2,NLAT) 
      COMMON /COMTEN/ QTEN(NLONP2,NLEV,NLAT),TTEN(NLONP2,NLEV,NLAT) 
     *               ,UTEN(NLONP2,NLEV,NLAT),VTEN(NLONP2,NLEV,NLAT) 
      COMMON /COMGLB/  GLBCLD(NLONP2,NLEV,NLAT) 
      COMMON /TABL2R/ SDWSW(NLONP2,NLAT), SUPSW(NLONP2,NLAT), 
     *                SDWLW(NLONP2,NLAT), SUPLW(NLONP2,NLAT), 
     *                TDWSW(NLONP2,NLAT), TUPSW(NLONP2,NLAT), 
     *                 TOLR(NLONP2,NLAT), TNETM(NLONP2,NLAT), 
     *               SDWSWC(NLONP2,NLAT),SUPSWC(NLONP2,NLAT), 
     *  SDWLWC(NLONP2,NLAT), TOLRC(NLONP2,NLAT), TUPSWC(NLONP2,NLAT), 
     *  TOTCLD(NLONP2,NLAT), TOTWAT(NLONP2,NLAT),TOTICE(NLONP2,NLAT) 
      COMMON /COMFAS/ CLDFAS(NLONP2,NLAT), 
     *                KTFAS(NLONP2,NLAT),KBFAS(NLONP2,NLAT) 
      DIMENSION             RHG(KL),ERZ(NLAT,KST) 
      COMMON /WK27/ W1(NLONP2,NLAT,7), HM(54) 
Cnor      COMMON /NZAP/ NZAP 
      COMMON /EEEZ/ PST(KST) 
Cnor      COMMON /IZAP/ NZAPKT 
C      COMMON /PDXYZ/ POX(NLONP2,NLAT,NLEV,NTR),DOX(NLONP2,NLAT,NLEV,NTR) 
      COMMON/PSXXX/ PSXX(NLONP2,NLAT) 
      DIMENSION PSTEQ(KST),WK2(NLONP2,NLAT),PI(NLONP2,NLAT),NTIMS(12) 
      DIMENSION TZ(NLAT+3),RFLX(NLAT+3,8),AAA(8),BBB(NLEV),CCC(NLATM1) 
      DIMENSION KEY0(20) 
      real*8 tmr1, tmr2 
      real extime,cputime(2) 
      REAL,DIMENSION (NLONP2) :: alon=(/(-185.+5.*i,i=0,NLONP2-1)/)     ! Longitude
      REAL,DIMENSION (NLAT) :: alat=(/(-92.+4.*j,j=0,NLAT-1)/)          ! Latitude
      data psteq /3.E-8,                                                ! Pressure levels for model output
     &            1.e-7,2.e-7,5.e-7,1.e-6,2.E-6,3.E-6,5.E-6,            
     $            1.E-5,2.E-5,5.E-5,1.E-4,2.E-4,3.e-4,5.e-4, 
     *            0.001,0.002,0.003,0.005,0.007,0.01, 0.02 , 
     *            0.03, 0.05, 0.07, 0.1,  0.15, 0.2,  0.25 , 
     *            0.3,  0.4,  0.5,  0.6,  0.7,  0.85, 0.925, 
     *            1.000      / 
      DATA LNMON /31,28,31,30,31,30,31,31,30,31,30,31/ 
C 
C                 Mid month days
C                 JAN16,FEB14,MAR16,APR15,MAY16,JUN15, 
C                 JUL16,AUG16,SEP15,OCT16,NOV15,DEC16 
C 
        DATA NTIMS /  16,  45,  75, 105, 136, 166, 
     *               197, 228, 258, 289, 319, 350 / 
C 
C                      NTIM = 28856 FOR 1 JANUARY 1979 
C                  ------------------- 
C      CALL MPI_INIT(IERR) 
      DO K=1,KST
         PST(K)=PSTEQ(K)
      END DO
      IFLAG=0
      IARX=0
      KTSTEP=6              ! KT: in 6 steps
      CALL DAY                                                         ! check for stop running 

      OPEN (9,FILE='OTBET')
      RADVAR = 1.0E0
      CALL ROUT
      CALL BEREIT
      CALL CHTKT                                                       ! KT Reading
      CALL CHTXX                                                       ! Reading XXALL for chemistry arrays
      OPEN (7,FILE='NDIN.DAT')
      READ (7,*) NDINR
         WRITE (*,*) 'NDIN = ',NDINR
      CLOSE (7)
      CALL ZERDAY
      CALL ZERMON
      IF (KEY(6).NE.1) CALL CHTAVR
      CALL MTRX
C      CALL AIRMAS(AMASS0) 
      AMASS0 = 10040.04E0 
               NHRS=KEY(5) 
               NDAY=KEY(6) 
               NMON=KEY(7) 
               NYAR=KEY(8) 
               NHST=KEY(9) 
               NUM=KEY(11) 
               IMON=KEY(12) 
               NCHT=KEY(13) 
               NTIM=KEY(14) 
               MON2=KEY(15) 
               IYR2=KEY(16) 
               MDAY=KEY(18) 
C 
              MDAY1=KEY(17)       ! without annual cycle: 0 
C                                 ! with annual cycle   : 28,29,30,31 
C 
            ICYCLE = KEY(10)      ! without diurnal cycle: 0 
C                                 ! with diurnal cycle   : 1 
C 
C                
C                 MDAY1=KEY(17)  ICYCLE = KEY(10) 
C                           define 
C                     4 versions for RADIA : 
C                 1 - with diurnal and annual cycles 
C                        (RADIA 8 ) 
C                 2 - without diurnal and annual cycles 
C                        (RADIA 1 ) 
C                 3 - without diurnal but with annual cycles  
C                        (RADIA 1 ) 
C                 4 - with diurnal but without annual cycles  
C                        (RADIA 8 ) 
C 
C 
C                     RADVAR = 0 (OLD RADIA), RADVAR = 1 (NEW RADIA) 
      IF (RADVAR.GT.0.5E0) CALL RADDAT 
C
      CALL PARAM(IMON) 
      IF (MDAY1.EQ.0) THEN 
         NTIM = 28855 + NTIMS(IMON) 
         GO TO 6                   ! goto (PERPETUAL) month
      ENDIF                        ! without annual cycle 
C 
      IYR1=IYR2 ! 1979 
      MON1=MON2-1 
      IF (MON1.EQ.0) THEN 
         MON1=12 
         IYR1=IYR2-1 ! 1978 
      END IF  
      CALL SSTICR(IYR1,MON1,LM1,LY1,SST1,SIC1)
      CALL SSTICR(IYR2,MON2,LM2,LY2,SST2,SIC2) ! 1979
C                                                ===
      WRITE (*,*) 'LM1,LY1== ',LM1,LY1
      WRITE (*,*) 'LM2,LY2== ',LM2,LY2
      CALL SSTLIN(NDAY,IMON,NYAR) ! 1979)
    6 CONTINUE 
      CALL ZERHR 
      N=0 
Cnor      NZAP=0 
      IRAD=0 
         TIMOLD = SECONDS() 
 
Cgalin                   Next line vvodim do metki 99 
C      CALL HISNUL 
      CALL DAYNUL 
 
      IF(KEY(1).EQ.24) THEN 
         IF(KEY(3).NE.KEY(7)) THEN 
            CALL MKKTXX 
         END IF 
      END IF
      OPEN(38,FILE='RES/PSXXA',STATUS='UNKNOWN',
     $   FORM='UNFORMATTED',ACCESS='DIRECT',RECL=NLONP2*NLAT*IA)
         READ (38,REC=1)((PSXX(I,J),I=1,NLONP2),J=1,NLAT)
      CLOSE(38)
      NCHEM=1 
      call boxdat 
      CALL SPSDNM1          ! *** from SPS to DNM for both time slices
      CALL PRTMR(XX,NLONP2,NLEV,NTR,NLAT,2,36,NLEV,9,23,16,'SPSDNM1 ')
      NMONS=0
      extime = etime(cputime)
      TIMCRD=cputime(1)
!	open (50,file='Mozhaika.dat',status='UNKNOWN') 
      KEY0=KEY
  99  CONTINUE
!
! ************************** D I U R N A L   C Y C L E ******************* 
! 
      N=N+1 
      ITYEAR=NYAR
      NSPS=NDAY
      DO IM=1,IMON-1
         NSPS=NSPS+LNMON(IM)
      ENDDO

!
! ************************** S T A R T  C H E M I S T R Y ****************
! 
      IF (NCHEM.EQ.1) THEN 
         !NSPS=NUM+1 !(IMON-1)*30 + NDAY 
         !IF (NDAY.GT.30) NSPS=(IMON-1)*30 + 30 
         write (*,*) 'IMON,NDAY,NSPS,NGMT',IMON,NDAY,NSPS,NHRS+N 
         CALL ZIMBOX(NSPS,IMON,NHRS+N) 
         write (*,*) 'end ZIMBOX in DNM' 
         NCHEM=2 
      ENDIF 
!
! ************************** E N D  C H E M I S T R Y *******************
! 
      extime = etime(cputime)
      TIMCRN=cputime(1)
      CALL ZERTEN
C 
      IADJ = 1                             ! ADJ works with IADJ = 1 
      CALL FASFL                           ! MY OLD KUO AND ADJ
      IEPSR=MOD(N-1,3)
      IF (IEPSR.NE.0) GO TO 312
!
! ***************** Radiation One Time for Three Hours ************
!
      IF (MDAY1.NE.0.AND.ICYCLE.EQ.1)THEN
         CALL SUNGL(NTIM ,NHRS+N ,COZ,CDISSE,KEY) 
!         print *,NTIM ,NHRS+N ,COZ(2,:)!,CDISSE !; pause  
!         CALL ASTRO_SPS(NYAR,IMON,NDAY,NHRS+N,ALAT,ALON,NLAT,NLONP2,
CSPS         CALL ASTRO_SPS(1979,IMON,NDAY,NHRS+N,ALAT,ALON,NLAT,NLONP2,  ! *** SPS ***
CSPS     $                     COZ,CDISSE)
!         print *,NTIM ,NHRS+N,CDISSE,KEY(8),KEY(12),KEY(6),KEY(17) 
!         print *,KEY0
!         pause 7
         IRAD=1                                 
         DO 146 J=1,NLAT                        
  146       HSG(J) = 1.0E0                         
      ENDIF
  713 CONTINUE 
      IF (IRAD.EQ.0) GO TO 312 
      IRAD=0 
      CALL VERVEL
!
!       SPS /06/07/2007/ added CO2 year-to-year variations
!
!      print *,' Before RADFL2'
      CALL RADFL2
!      print *,' After RADFL2'
 1961 FORMAT('  RADIA TIME : ',F8.3) 
C--------------------------------------------------------------- 
      IGAL = 0.0 
  715 CONTINUE 
  312 CONTINUE 
C
C ************************ END of Radiation Code ****************
C
      CALL GWD 
      CALL DSP 
      CALL PBLDAT 
      CALL PBL              ! PLANETARY BOUNDARY LAYER 
 
      NDIN = NDINR      ! 9      ! 12          ! 9 
!      CALL SPSDNM2                     ! ***** SPS *****
      DT = DT/FLOAT(NDIN)
!      extime = etime(cputime)
!      TIMCR0=cputime(1)
      CALL DYN_PREP
!      extime = etime(cputime)
!      TIMCR1=cputime(1)
!      PRINT *,' DTIM =',TIMCR1-TIMCR0
      DO INDIN=1,NDIN
!
! **************************** DYNAMICS *************************
!
!         print *,' INDIN=',INDIN
!          CALL DYN_SPS(DT)                 ! ***** sps *****
!      extime = etime(cputime)
!      TIMCR2=cputime(1)
!      PRINT *,' INDIN=',INDIN,' DTIM DYN_SPS =',TIMCR2-TIMCR1
!          CALL SPSDNM2                     ! ***** SPS *****
!      extime = etime(cputime)
!      TIMCR3=cputime(1)
!      PRINT *,' DTIM SPSDNM  =',TIMCR3-TIMCR2
!      CALL PRTMR(XX,NLONP2,NLEV,NTR,NLAT,2,36,NLEV,9,23,16,'SPS CH4 ')
!      print *,' CH4 ',XX(36,1,7,23,1),XX(36,1,7,23,2)
          CALL DYNIMP(NDIN)
!      extime = etime(cputime)
!      TIMCR4=cputime(1)
!      PRINT *,' DTIM DYNIMP  =',TIMCR4-TIMCR3
!      CALL PRTMR(XX,NLONP2,NLEV,NTR,NLAT,2,36,NLEV,9,23,16,'DNM CH4 ')
!          CALL DNMSPS                      ! ***** SPS ***** 
!      extime = etime(cputime)
!      TIMCR1=cputime(1)
!      PRINT *,' DTIM SPSDNM  =',TIMCR1-TIMCR4
!          pause
!          CALL DYN_SPS(DT,NDIN)            ! ***** sps ****
!
! **************************** DAILY AVERAGE CHEMISTRY **********
!
!      write(50,*)' MON=',NMON,' DAY=',NDAY,' HRS=',NHRS+N
CSPS          CALL DYN_SPS(DT)                 ! ***** sps ***** 
CSPS          CALL SPSDNM2                     ! ***** SPS ***** 
       ENDDO
!       pause
       DT = DT*FLOAT(NDIN)
       CALL DNMSPS                      ! ***** SPS *****
       CALL DYN_SPS(2.*DT)                 ! ***** sps *****
       CALL SPSDNM2                     ! ***** SPS *****
!      extime = etime(cputime) 
!      TIMCR=cputime(1)  
!	PRINT *,' DTIM DYN =',TIMCR-TIMCRN 
!	TIMCRN=TIMCR
C          write (*,*) 'end DYN  ' 
C                             Atmospheric mass correction 
      CALL AIRMAS(AMASS) 
      COEF = AMASS0/AMASS 
      CALL ADJMAS(COEF) 
C 
      CALL QNEGAT 
      CALL XXNEGAT 
      CALL TNEGAT 
C                                       === 
 1216 FORMAT (2X,'ENERGY AFTER DYNIMP') 
      IF (IEPSR.NE.0) GO TO 313 
  313 CONTINUE 
C                                                === 
      CALL ACCHR 
      CALL ACCGLB 
 
      IF(N.NE.6) GO TO 99    ! *** BACK TO THE BEGINNING OF THE DIURNAL CYCLE
!
! ***************** EVERY 6 HOURS *******************************************
!
C                   --- 
      NHRS=NHRS+N 
      NHST=NHRS/KTSTEP
C ***************************************************************************
C
C ************************** Every 6 hour writing ***************************
C
C****************************************************************************
C      NL=57 ; Alat=60. ; Alon=30.
C      write(NL,'(4(a8,I8))')' Year ',NYAR,' Month ',Imon,
C     $' Day ',NSPS,' Hour ',NHRS
C      JP=1
C      do while(Alat > -92.+4.*(JP-1))
C         JP=JP+1
C      enddo
C      IP=1
C      do while(Alon > -185.+5.*(IP-1))
C         IP=IP+1
C      enddo
C      write(NL,'(3(a15,f10.3))')' Latitude ',-92.+4.*(JP-1),
C     $' Longitude ',-185.+5.*(IP-1),'Sur.pressure',PSDAY4(IP,JP) 
C      !pause 1
C      write(NL,'(8(1PE10.3))')XXALLY(IP,JP,:,:)
C**************************************************************************** 
      IF (NHRS.EQ.24) THEN 
!
! ****************************** D A Y  E N D ***************************
! 
         NCHEM=1                  ! KEY FOR CHEMISTRY
C         CALL DNMSPS              ! FROM DNM TO SPS
         CC=0.0E0 
         DO 33 J=2,JL 
   33       CC=CC+COS(SHIR(J)) 
         CC=CC*72.0E0 
         PRINT 77,(FAL(K)/(8.0E0*CC),K=2,11) 
   77    FORMAT(2X,10F8.3/) 
         DO 25 LI=2,11 
   25       FAL(LI)=0.0E0 
         FAL3=0.0 
         FAL4=0.0 
	   FAL5=0.0 
         DO J = 2,46 
            CC=COS(SHIR(J)) 
            DO I = 2,73 
               FAL3=FAL3+TOTWAT(I,J)*CC 
               FAL4=FAL4+TOTICE(I,J)*CC 
               FAL5=FAL5+(FG(I,J)+SG(I,J))*CC 
            END DO 
         END DO 
         CC=0.0E0 
         DO J=2,46 
            CC=CC+COS(SHIR(J)) 
         END DO 
         CC=CC*72.0E0 
         FAL3=FAL3/CC 
         FAL4=FAL4/CC 
         FAL5=FAL5/CC 
         FAL6=FAL3+FAL4 
         WRITE (*,*) 'WAT+ICE ,GAL =',FAL3,FAL4,FAL6,FAL5 
      ENDIF 
C 
      KEY(1)=NHRS 
      KEY(2)=NDAY 
      KEY(3)=NMON 
      KEY(4)=NYAR 
      KEY(9)=NHST 
C 
C--------------------------------------------- 
      IF (NHRS.NE.24) GO TO 1007 
      WRITE (9,*) 'end_of_day MDAY, NDAY, IMON = ',MDAY, NDAY, IMON 
      WRITE (*,*) 'end_of_day MDAY, NDAY, IMON = ',MDAY, NDAY, IMON 
      numhis = NDAY 
      imont = IMON 
      extime = etime(cputime)
      TIMCR=cputime(1)
      PRINT *,' DTIM DDAY =',TIMCR-TIMCRD
      TIMCRD=TIMCR
C--------------------------------------------- 
      IF (NDAY.NE.MDAY) GO TO 1008 
C 
      IF (MDAY1.EQ.0) THEN 
         NMON=NMON+1 
         NYAR=NYAR+1          
      ELSE 
         NMON=NMON+1 
         IMON=IMON+1 
         IF (IMON.GE.13) IMON=1 
         NYAR=IYR2 
C                             ! USA 
C        NUM=IMON             ! USA 
C                             ! USA 
         CALL PARAM(IMON) 
         MDAY1=MDAY 
         MDAY=LNMON(IMON) 
C --------------------------- VISOKOSNYE ----- 
         IF (IMON.EQ.2) THEN 
            IVIS=MOD((NYAR-1976),4) 
            IF (IVIS.EQ.0) MDAY=29 
         END IF 
C --------------------------- 
         IFLAG=0 
      ENDIF                   ! END OF PERPETUAL MONTH 
      NDAY=0 
      IARX=1 
C 
 1008 CONTINUE 
C---------------------------- 
      NDAY=NDAY+1 
      NUM=NUM+1 
      IF (MDAY1.EQ.0) THEN 
         NHRS=0 
      ELSE 
         NTIM=NTIM+1 
C                                  ! USSR 
C        NUM=NDAY                  ! USSR 
C                                  ! USSR 
C----------------*** BEGN 16-TH DAY ***--------- 
         LOPEN = 0 
         IF(IMON.EQ.2.AND.NDAY.EQ.15) LOPEN = 1 
         IF(IMON.NE.2.AND.NDAY.EQ.16) LOPEN = 1 
         IF(LOPEN.EQ.1) THEN 
            DO 220 J=1,NLAT 
               DO 220 I=1,NLONP2 
                  SIC1(I,J)=SIC2(I,J) 
  220             SST1(I,J)=SST2(I,J) 
            LYAR=NYAR 
C1979            LYARF=1979
            LMON=IMON+1 
            IF(LMON.EQ.13) THEN 
               LMON=1 
               LYAR=NYAR+1 
C1979               LYARF=1980
            END IF 
            print *,' LYAR=',LYAR,' IYR2=',IYR2,' LYARF=',LYARF
            CALL SSTICR(LYAR,LMON,MON2,IYR2,SST,SIC) 
!            CALL SSTICR(LYARF,LMON,MON2,LY2,SST,SIC)
            DO 224 J=1,NLAT
               DO 224 I=1,NLONP2 
                  SST2(I,J)=SST(I,J) 
  224             SIC2(I,J)=SIC(I,J) 
C ---------------------------------------------- 
!            IF(MON2.EQ.LMON.AND.IYR2.EQ.LYAR) THEN 
!               PRINT *,'TAPE NORMAL CONDITIONS ',MON2,' IYEAR ',IYR2 
!               GO TO 112 
!            ELSE 
!               PRINT *,'TAPE AND CALL FOR TAPE ARE DIFFERENT, STOP' 
!               PRINT *,'LMON ',LMON,'MON2 ',MON2 
!               PRINT *,'LYAR ',LYAR,'IYR2 ',IYR2 
!               STOP 
!            ENDIF 
  112       CONTINUE 
C ------------------------------------------------- 
         ENDIF              ! DAY 16 IS OVER
         CALL SSTLIN(NDAY,IMON,NYAR) ! 1979 
      ENDIF                   ! END OF PERPETUAL MONTH 
      NHRS=0 
 1007 CONTINUE 
C                                  ! KT EVERY 6 HOURS (4 TIMES A DAY) 
C----------------------------------------------------- 
      KEY(5)=NHRS 
      KEY(6)=NDAY 
      KEY(7)=NMON 
      KEY(8)=NYAR 
      KEY(9)=NHST 
      KEY(11)=NUM 
      KEY(12)=IMON 
C     KEY(13)=NHRS/KTSTEP 
      KEY(14)=NTIM 
      KEY(15)=MON2 
      KEY(16)=IYR2 
      KEY(17)=MDAY1 
      KEY(18)=MDAY 
      OPEN(37,FILE='RES/DK.ICX',STATUS='OLD',FORM='FORMATTED', 
     * ACCESS='SEQUENTIAL') 
      READ(37,1022) KEY0 
      CLOSE(37) 
 1022 FORMAT(4I8) 
      CALL ZAPMON 
      CALL ZAPALL             ! ****** SPS ******* 
      CALL ZAPDAY 
      KDOB=KEY(1)/6 
      IF(KDOB.EQ.4) KDOB=0 
      NR=(KEY(11)-KEY0(11))*4+KDOB 
      print *,'wrhr, nr =',nr
!	write(50,*)' NR=',NR 
      CALL WRHR(NR) 
! 
! ********************** NEW DAY BEGINS ***************************
! 
      IF(KEY(1).EQ.24) THEN 
C         CALL PRT_SPS_MOZH(NMON,NDAY)
         NR=KEY(11)-KEY0(11) 
         print *,'wrday, nr =',nr 
         CALL WRDAY(NR) 
         CALL WRGLB(NR) 
         CALL ZERDAY 
         CALL DAYAVR(numhis,imont) 
         CALL DAYNUL 
!
! ********************** NEW MONTH BEGINS *************************
! 
         IF(KEY(3).NE.KEY(7)) THEN 
            MONAV=KEY(7)-KEY0(7) 
            print *,'wrmon, nr =',monav 
            CALL WRMON(KEY0(5),KEY0(6),KEY(2),MONAV) 
            CALL ZERMON 
            NMONS=0 
            write (*,*) 'end MON: NDAY, MDAY= ',NDAY, MDAY 
            KEY(13) = 0 
            CALL MKKTXX 
            CALL ZAPXX 
            CALL ZAPAVR 
            CALL ZAPKT 
            CALL DAY               ! end tasks (proverka finisha) 
            WRITE (*,32) KEY 
            GO TO 777
         END IF                 ! end MONTH 
 
C        end MON 
 
         MKK = MOD(NR,7) 
         IF(MKK.EQ.0) CALL MKKTXX 
 
C        zapkt: days = 6,11,16,21,26 
 
         KTZAP = 0 
         IF (NDAY.EQ.11.OR.NDAY.EQ.21) THEN 
            KEY(13) = 0 
CSPS            KTZAP = 1 
         ENDIF 
         IF ( NDAY.EQ.6.OR.NDAY.EQ.16.OR.NDAY.EQ.26) THEN 
            KEY(13) = 1 
CSPS            KTZAP = 1 
         ENDIF 
 
         IF (KTZAP.EQ.1) THEN 
            write (*,*) 'end DAY: NDAY, KEY(13)= ',NDAY, KEY(13) 
            CALL ZAPXX 
            CALL ZAPAVR 
            CALL ZAPKT 
            WRITE (*,32) KEY 
  32        FORMAT (35X,4I8) 
         END IF
      END IF                    ! end DAY

  777 CONTINUE

C     ! end DAY
      CALL ZERHR
      N=0
      IF (N.NE.77) GO TO 99
!
! *********************** BACK TO DIURNAL CYCLE ************************* 
!
      CLOSE (9)
C            CALL MPI_FINALIZE (IERR)
 8888   extime = etime(cputime)
       write(6,6741) cputime(1), cputime(2), extime
 6741     format(1x,'USER CPU =', F9.2,4X,'SYS CPU =',F9.2,10X,
     *  'TOTAL CPU (sec) =',F9.2)
      STOP
      END

C      SUBROUTINE PRT_SPS_MOZH(NL,NYAR,Imon,NDAY,NHR,Alat,Dlat,Alon,Dlon)
C      INCLUDE 'PRMT.INC'
C      INCLUDE 'garr.h'
C      INCLUDE 'xx.h'
!      write(50,*)' nmon=',NMON,' NDAY=',NDAY
!      write(50,100)XXALLY(37:72,24:46,:,1:4)
!      write(50,100)XXALLD(37:72,24:46,:,1:1)
!      write(50,100)XXALLP(:,:,:,1:4)
C 100  FORMAT(8(1PE10.3))
C      RETURN
C      END

      SUBROUTINE PRTMR(XX,NLONP2,NLEV,NTR,NLAT,NV,ILON,ILEV,IGAS,ILAT1,
     $MU,GNAME)
      REAL XX(NLONP2,NLEV,NTR,NLAT,NV)
      CHARACTER*8 GNAME
      PRINT *,GNAME,XX(ILON,ILEV,IGAS,ILAT1,1)*29./MU,
     $XX(ILON,ILEV,IGAS,ILAT1,2)*29./MU
      RETURN
      END
C
C ******************************************************************
C
      SUBROUTINE ASTRO_SPS(NYEAR,NMONTH,NDAY,NSTEP,ALAT,ALON,NLAT,NLON,
     $                     COSZ,CDISSE)
C***********************************************************************
C
C  INPUT:
C  ======
C    NYEAR     : CURRENT YYMMDD
C    NMONTH     : CURRENT HHMMSS
C    NDAY     : CURRENT YYMMDD
C    NHMS     : CURRENT HHMMSS
C    ALAT(JM) : LATITUDES  IN DEGREES.
C    ALON(IM) : LONGITUDES IN DEGREES. (0 = GREENWICH, + = EAST).
C    IM, JM   : # OF LONS AND LATS.
C
C  OUTPUT:
C  =======
C    COSZ(IM,JM) : COSINE OF ZENITH ANGLE.
C    RA          : EARTH-SUN DISTANCE IN UNITS OF
C                  THE ORBIT'S SEMI-MAJOR AXIS.
C
C  NOTE:
C  =====
C  THE INSOLATION AT THE TOP OF THE ATMOSPHERE IS:
C
C  S(I,J) = (SOLAR CONSTANT)*(1/RA**2)*COSZ(I,J),
C
C  WHERE:
C  RA AND COSZ(I,J) ARE THE TWO OUTPUTS OF THIS SUBROUTINE.
C
C***********************************************************************
C*                  GODDARD LABORATORY FOR ATMOSPHERES                 *
C***********************************************************************
C
C      INCLUDE 'PRMT.INC'
C      PARAMETER ( IM = NLON, JM = NLAT-1 )
      DIMENSION COSZ(NLON,NLAT), ALAT(NLAT), ALON(NLON), HC(NLON)
      INTEGER YEAR, DAY, SEC
      REAL PI, ZERO, ONE, TWO, SIX, DG2RD, YRLEN, EQNX, OB, ECC, PER
      REAL DAYLEN, FAC, THM, THP, THNOW, ZS, ZC, SJ, CJ
      PARAMETER (PI = 3.1415926535898)
      PARAMETER (ZERO=0.,ONE=1.,TWO=2.,SIX=6.)
      PARAMETER (DG2RD=PI/180.)
C
      INTEGER    DAYSCY
      PARAMETER (YRLEN=365.25,DAYSCY=365*4+1)
      PARAMETER (DAYLEN=86400.)
CCC      PARAMETER (EQNX=80.9028)
CCC      PARAMETER (OB=23.45*DG2RD, ECC=.0167, PER=102.0*DG2RD)
C                             for AMIP2
      PARAMETER (OB=23.441*DG2RD, ECC=.016715, PER=102.7*DG2RD)
C
      REAL TH(DAYSCY),T0,T1,T2,T3,T4,FUN,Y,MNDY(12,4)
C
      LOGICAL FIRST
      DATA    FIRST/.TRUE./
      SAVE
C
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     *           397,34*0 /
C
      FUN(Y) = (TWO*PI/((ONE-ECC**2)**1.5))*(ONE/YRLEN)
     *       * (ONE - ECC*COS(Y-PER)) ** 2
      NSECF(N) = N/10000*3600 + MOD(N,10000)/100* 60 + MOD(N,100)
C
C***********************************************************************
C*                          SET CURRENT TIME                           *
C***********************************************************************
C
      COSZ=0.
      NYMD =   (NYEAR-1900)*10000 + NMONTH*100 + NDAY
      N = NSTEP                       ! for zim : 1,...,24 ot T_loc
      IF (N.LT.0 ) N = 24 + N
      IF (N.GT.24) N = N - 24
      NHMS = N * 10000
      YEAR  = NYMD / 10000
      MONTH = MOD(NYMD,10000) / 100
      DAY   = MOD(NYMD,100)
      SEC   = NSECF(NHMS)
      !print *,NYMD,YEAR,MONTH,DAY,SEC
C
C***********************************************************************
C*                          SET EQNX for AMIP2                         *
C***********************************************************************
C
      IY = 1900 + NYMD / 10000
      Y = float(IY)
      FY = Y / 4.0
      IFY = int(FY)
      Ymod4 = Y - float(IFY)*4.0
      X = 20.41 - 0.0078 * (Y-1987.0) + 0.25 * Ymod4
C --------------------------- VISOKOSNYE -----
      VDAY = 0.0
      IF (MONTH.EQ.2) THEN
         IVIS=MOD(IY,4)
         IF (IVIS.EQ.0) VDAY = 1.0
      END IF
C ---------------------------
      EQNX = 31.0 + ( 28.0 + VDAY ) + X
C
C***********************************************************************
C*                 COMPUTE DAY-ANGLES FOR 4-YEAR CYCLE                 *
C***********************************************************************
C
      IF(FIRST) THEN
         DO K = 2,4
            IST =1
C           IF (K == 2) IST = 3
            IF (K.EQ.2) IST = 3
            DO I=IST,12 !5,48
               MNDY(I,K) = MNDY(I,K-1) + 365
            ENDDO
         ENDDO
         KM  = INT(EQNX) + 1
         FAC = KM-EQNX
         T0 = ZERO
         T1 = FUN(T0         )*FAC
         T2 = FUN(ZERO+T1/TWO)*FAC
         T3 = FUN(ZERO+T2/TWO)*FAC
         T4 = FUN(ZERO+T3    )*FAC
         TH(KM) = (T1 + TWO*(T2 + T3) + T4) / SIX
         DO 200 K=2,DAYSCY
            T1 = FUN(TH(KM)       )
            T2 = FUN(TH(KM)+T1/TWO)
            T3 = FUN(TH(KM)+T2/TWO)
            T4 = FUN(TH(KM)+T3    )
            KP = MOD(KM,DAYSCY) + 1
            TH(KP) = TH(KM) + (T1 + TWO*(T2 + T3) + T4) / SIX
            KM = KP
 200        CONTINUE
         FIRST=.FALSE.
      ENDIF
C
C***********************************************************************
C*            COMPUTE EARTH-SUN DISTANCE TO CURRENT SECOND             *
C***********************************************************************
C
      IDAY   = DAY + MNDY(MONTH,MOD(YEAR,4)+1)
      IDAYP1 = MOD( IDAY,DAYSCY) + 1
      THM    = MOD( TH(IDAY)  ,TWO*PI)
      THP    = MOD( TH(IDAYP1),TWO*PI)
      IF(THP.LT.THM) THP = THP + TWO*PI
      FAC   = FLOAT(SEC)/DAYLEN
      THNOW = THM*(ONE-FAC) + THP*FAC
      !print *,' THNOW=',THNOW,' OB=',OB,SEC,DAYLEN,FAC
      ZS = SIN(THNOW) * SIN(OB)
      ZC = SQRT(ONE-ZS*ZS)
      RA = (1.-ECC*ECC) / ( ONE-ECC*COS(THNOW-PER) )
C
C***********************************************************************
C*                 COMPUTE COSINE OF THE ZENITH ANGLE                  *
C***********************************************************************
      FAC = FAC*TWO*PI + PI
      DO 300 I=1,NLON
         HC(I) = COS( FAC+ALON(I)*DG2RD )
         !print *,i,SEC,FAC,alon(i),hc(i)
  300    CONTINUE
      !print *,HC
 500   DO 400 J=1,NLAT
         SJ = SIN(ALAT(J)*DG2RD)
         CJ = SQRT(ONE-SJ*SJ)
         !print *,j,alat(j),sj,cj,sin((alat(j)+360)*DG2RD)
         DO 400 I=1,NLON
            !print *,J,I,NLON,NLAT
            COSZ(I,J) = SJ*ZS + CJ*ZC*HC(I)
            IF ( COSZ(I,J).LT.ZERO ) COSZ(I,J) = ZERO
 400        CONTINUE
      CDISSE = 1.0 / (RA**2)
      !print *,COSZ(:,2)
      !pause 778
      R E T U R N
      E N D
