      SUBROUTINE HSRP(NCH,FLN,NGG)
C234567890123456789012345678901234567890123456789012345678901234567890
      INCLUDE 'din.h' 
      PARAMETER(MAIR=36,LAIR=38,NG=4,LAIRL=LAIR+1,MAIRM=MAIR+1)
      CHARACTER RED*50, FLN*50
      DIMENSION EMR(LAIR,MAIR,NG),F0(MAIR),Z0(LAIR),ALTST(LAIRL),
     *F0ST(MAIRM),AMUAIR(4),PRES0(LAIR),EI(NG)
      DATA AMUAIR/18.,46.,15.,28./, RZ/6.371E8/, PI/3.141592/
      DATA EI/1237.,1000.,1000.,1000./
      OPEN(UNIT=NCH,FILE=FLN,STATUS='UNKNOWN')
      READ(NCH,100)RED
      READ(NCH,'(I2,I4)')NLAT,NLEV
      READ(NCH,'(6F9.4)')(F0(K),K=1,NLAT)
      READ(NCH,'(6F10.4)')(PRES0(I),I=1,NLEV)
 100  FORMAT(A50)
 101  FORMAT(A8)
      DO 3 I=1,NLEV
   3     Z0(I)=7.*ALOG(1000./PRES0(I))
      DO 1 J=1,NGG
         READ(NCH,101)RED
   1     READ(NCH,110)((EMR(I,K,J),K=1,NLAT),I=1,NLEV)
      PRINT *,' HSCT EMISSION FROM  ',FLN
      F0ST(1)=-90.
      DO 2 K=2,NLAT
 2       F0ST(K)=0.5*(F0(K-1)+F0(K))
      F0ST(NLAT+1)=90.
c      ALTST(1)=0.
c   Bcs the bottom layer is actually two times thicker
      ALTST(1)=-0.5*(z0(2)+z0(1))*1.e5
      DO 8 I=2,NLEV
 8       ALTST(I)=0.5*(Z0(I-1)+Z0(I))*1.E5
      ALTST(NLEV+1)=Z0(NLEV)*1.E5
C**************************************************************************
C
C     Now convert from kg/day to molecules/cm3-sec
C
C     mol/cm3-sec = Na*EI(g/kg)/(dX*dY*dZ*mu*Tsut) kg/day
C                 = Na*EI/(2*PI*Ra*sin((FI1)-sin(FI0))*Ra*dZ*mu*Tsut)
C
C     For NOx EI=1000 (g/kg), because EI is taken into accout at input data
C     For H2O EI=1237 (g/kg)
C
C**************************************************************************
      DTR=3.141592/180.
      DO 510 I=1,NLEV
         DO 510 K=1,NLAT
            DO 510 J=1,NGG
 510           EMR(I,K,J)=EMR(I,K,J)*6.0225E23*EI(J)/(86400.*AMUAIR(J)*
     *         2.*PI*(SIN(F0ST(K+1)*DTR)-SIN(F0ST(K)*DTR))*RZ*RZ*
     *         (ALTST(I+1)-ALTST(I)))
      DO 4 J=1,NGG
         DO 5 I=1,L
            DO 5 K=1,M
               EM(I,K,J)=0.
 5          continue   
         CALL LNT2(EMR(1,1,J),Z0,F0,LAIR,MAIR,EM(1,1,J),ZKM,FI,L,M,
     *   NLEV,NLAT)
         DO 7 I=1,L
            IF(ZKM(I).GT.Z0(NLEV))GOTO7
            DO 6 K=1,M
               IF(ABS(FI(K)).LT.F0(NLAT))GOTO6
               IF(FI(K).LT.0.)THEN
                  NLATT=1
               ELSE
                  NLATT=NLAT
               ENDIF
               EM(I,K,J)=EMR(I,NLATT,J)
   6           CONTINUE
   7        CONTINUE
   4     CONTINUE
 110  FORMAT(6(E12.5,1X))
      CLOSE(NCH)
      RETURN
      END

      SUBROUTINE LNT2(FIN, ZIN, YIN, NZIN, NYIN,
     *                 FOUT,ZOUT,YOUT,NZOUT,NYOUT,NLEV,NLAT)
      DIMENSION FIN(NZIN,NYIN),   ZIN(NZIN),  YIN(NYIN),
     *          FOUT(NZOUT,NYOUT),ZOUT(NZOUT),YOUT(NYOUT)
      DO 1 I=1,NZOUT
         II=1
         DO WHILE(ZIN(II)+0.1.LT.ZOUT(I))
            II=II+1
            IF(II.GT.NLEV)GOTO1
         ENDDO
         IF(II.EQ.1)II=II+1
         ZXP=ZIN(II)-ZOUT(I)
         ZXM=ZOUT(I)-ZIN(II-1)
         ZNZ=1./(ZIN(II)-ZIN(II-1))
         DO 2 K=1,NYOUT
            KK=1
            DO WHILE(YIN(KK)+0.1.LT.YOUT(K))
               KK=KK+1
               IF(KK.GT.NLAT)GOTO2
            ENDDO
   3        IF(KK.EQ.1)KK=KK+1
            YXP=YIN(KK)-YOUT(K)
            YXM=YOUT(K)-YIN(KK-1)
            ZN=ZNZ/(YIN(KK)-YIN(KK-1))
            FOUT(I,K)=((FIN(II-1,KK-1)*ZXP+FIN(II,KK-1)*ZXM)*YXP+
     *      (FIN(II-1,KK)*ZXP+FIN(II,KK)*ZXM)*YXM)*ZN
   2        CONTINUE
   1     CONTINUE
      RETURN
      END

